void mouseReleased()
{
  GlobalDragging = false;
  //  for (int i=0; i != FeedAButtons.length;i++)  FeedAButtons[i].display();
  //  for (int i=0; i != FeedBButtons.length;i++)  FeedBButtons[i].display();   
  if (OpenMenuID == 0)
  {
    for (int i=0; i != CommonButtons.length;i++)  CommonButtons[i].display();
    for (int i=0; i != BlendButtons.length;i++)  BlendButtons[i].display();   

    FeedAButtons[12].display();
    FeedAButtons[13].display();    
    FeedBButtons[12].display();
    FeedBButtons[13].display();
  }
  if(OpenMenuID == 2) GUIMenus[2].display();
}

void keyPressed()
{
  if (key == 'r') UpdateWorkspace = true;
  
  if (key == 'x') 
  {
   StepThroughVar++;
    if(StepThroughVar >= MaxPixels) 
    {
      println("Reset");
    StepThroughVar = 0;
    }  
  }


  if (key == CODED) 
  {
    switch(keyCode)
    {
    case UP:
//      println("Up on "+SliderPointer);
      SliderPointer.Value--;
      SliderPointer.setValue(SliderPointer.Value);
      break;

    case DOWN:
//      println("Down on "+SliderPointer); 
      SliderPointer.Value++;    
      SliderPointer.setValue(SliderPointer.Value);
      break;
    case RIGHT:
//      println("Right on "+SliderPointer);
      SliderPointer.Value++;
      SliderPointer.setValue(SliderPointer.Value);
      break;

    case LEFT:
//      println("Left on "+SliderPointer); 
      SliderPointer.Value--;    
      SliderPointer.setValue(SliderPointer.Value);
      break;
    }
    HandleSliders(false); //false means don't use mouse location for move()
  }


}//end keyPressed()

void mousePressed()
{
  if (mouseButton == RIGHT) println("X: "+mouseX+" - Y: "+mouseY); 

  //This has to be first since the Common buttons can be pressed regardless of menu states
  for (int i=7; i != CommonButtons.length;i++)
  {
    if (CommonButtons[i].over())
    {
      HandleCommonButtons(i);
    }//end over() if
  }//end for() 

  if (OpenMenuID != 0)
  {
    for (int i=1; i != GUIMenus.length;i++) 
    {
      if (GUIMenus[i].over() && i == OpenMenuID)
      {
        println("This "+i+" has been pressed");

        switch(i)
        {
        case 1: //offset Menu
          for (int x=0; x != OffsetButtons.length;x++) 
          {
            if (OffsetButtons[x].over())
            {
              if (FeedFlag == true) //A
              {
                switch(x)
                {
                  //These all should reference the object
                case 0: //up
                  QuickFeeds[FeedASelQuick].OffsetY++; 
                  break;
                case 1: //down
                  QuickFeeds[FeedASelQuick].OffsetY--; 
                  break;              
                case 2: //right
                  QuickFeeds[FeedASelQuick].OffsetX--;
                  break;            
                case 3: //left
                  QuickFeeds[FeedASelQuick].OffsetX++;
                  break;    
                case 4: //reset
                  QuickFeeds[FeedASelQuick].OffsetY = 0;
                  QuickFeeds[FeedASelQuick].OffsetX = 0;  
                  break;
                }//end switch
              }//end if
              else
              {
                switch(x)
                {
                case 0:
                  QuickFeeds[FeedBSelQuick].OffsetY++; 
                  break;
                case 1: //down
                  QuickFeeds[FeedBSelQuick].OffsetY--; 
                  break;              
                case 2: //right
                  QuickFeeds[FeedBSelQuick].OffsetX--;
                  break;            
                case 3: //left
                  QuickFeeds[FeedBSelQuick].OffsetX++;
                  break;    
                case 4: //reset
                  QuickFeeds[FeedBSelQuick].OffsetY = 0;
                  QuickFeeds[FeedBSelQuick].OffsetX = 0; 
                  break;
                }//end switch
              }//end else
              return; //don't check for anything else
            } //end offset over()
          }//end for
          break;        
        case 2: //Main Menu

        for (int q=0; q != MainMenuButtons.length;q++)
          {
            if (MainMenuButtons[q].over())
            {
              if(q > 5 && q != 10)
             {
             MainMenuButtons[6].Selected = false;
             MainMenuButtons[6].display();
             MainMenuButtons[7].Selected = false; 
             MainMenuButtons[7].display();             
             MainMenuButtons[8].Selected = false;   
             MainMenuButtons[8].display();             
             MainMenuButtons[9].Selected = false;               
             MainMenuButtons[9].display();
             }              
              
              MainMenuButtons[q].Selected =! MainMenuButtons[q].Selected;
              MainMenuButtons[q].display();
              
              switch(q)
              {
                case 0: // Save to config
                //currently not needed since most configuration settings can't be changed in software, do it in a text editor
                LoadFileMethod = 1;
                //selectOutput("Select a Device INI file to Save To:", "fileSelected");
                break;
                case 1: // Load Config File
                LoadFileMethod = 2;
                //selectInput("Select a Device Config file to Load:", "fileSelected");
                break;
                case 2: // Enable Serial Control
                Matrix.softwareSerialConEnable = MainMenuButtons[q].Selected;
                break;              
                case 3: // Enable DShow     
                Matrix.softwareEnableDSVideoFeed = MainMenuButtons[q].Selected;      
                break;         
                case 4: // Large Previews
                Matrix.softwareLrgPreviewEnable = MainMenuButtons[q].Selected;                      
                break;                       
                case 5: // Enable Midi     
                Matrix.softwareMIDIenable = MainMenuButtons[q].Selected;
                if(Matrix.softwareMIDIenable == true)
                {
               InitializeMIDI(true);
               InitializeMIDI(false);      
               GUIMenus[OpenMenuID].display();
                }             
                break;
                // Communication Types
                case 6: // None     
                CommunicationType = 0;
                OpenConnection();
                break;         
                 case 7: //Serial     
                CommunicationType = 1; 
                OpenConnection();
                break;
                case 8: //TCP
                CommunicationType = 3;
                OpenConnection();
                break;        
                case 9: //UDP
                CommunicationType = 2;
                OpenConnection();
                break;   
                case 10: //EULA
                link("http://creativecommons.org/licenses/by/4.0/legalcode");
                break;     
               case 11: //Rebuild Thumbnails
                BuildAndSaveThumbnails();
                break;                   
              }                
            }//end over() if
          }//end for()        
        
        //===============================================================================
        
          println(GUIMenus[2].xpos+" : "+GUIMenus[2].ypos);
          if (round(mouseX / SF) >=  GUIMenus[2].xpos+320 && round(mouseX / SF) <= GUIMenus[2].xpos+400)
          {
            if (round(mouseY / SF) >= GUIMenus[2].ypos+85  && round(mouseY / SF) <= GUIMenus[2].ypos+100) 
            {    
              println("At least here 1 ");
              frame.setSize(640, 480+30);
            }
            else if (round(mouseY / SF) >= GUIMenus[2].ypos+100  && round(mouseY / SF) <= GUIMenus[2].ypos+115) 
            {    
              println("At least here 2");
              frame.setSize(800, 600+30);
            }
            else if (round(mouseY / SF) >= GUIMenus[2].ypos+115  && round(mouseY / SF) <= GUIMenus[2].ypos+130) 
            {    
              println("At least here 3");
              frame.setSize(1024, 768+30);
            }
            else if (round(mouseY / SF) >= GUIMenus[2].ypos+130  && round(mouseY / SF) <= GUIMenus[2].ypos+145) 
            {    
              println("At least here 4");
              frame.setSize(1400, 1050+30);
            }
            else if (round(mouseY / SF) >= GUIMenus[2].ypos+145  && round(mouseY / SF) <= GUIMenus[2].ypos+160) 
            {    
              println("At least here 5");
              open("data/config.ini");
            }
          }
          break;
        case 3: //Configure Menu

          break;
        case 4: //Gen Menu  A
          for (int q = 0; q !=GenerationSliders.length;q++) 
          {
            if (GenerationSliders[q].over())
            {
              println("Selected "+q);
              SelectedSlider = q;
              GenerationSliders[q].selectSlider();
            }
          }
          break;
        case 5: //Gen Menu  B
          for (int q = 0; q !=GenerationSliders.length;q++) 
          {
            if (GenerationSliders[q].over())
            {
              println("Selected "+q);
              SelectedSlider = q;
              GenerationSliders[q].selectSlider();
            }
          }        
          break;
        }//end i switch
      } //end if
    }//end for
    
    
        if(FeedAButtons[8].over() && OpenMenuID == 1)
        {
          println("Pressed Offset Button on FeedA");
          FeedAButtons[8].Selected = false;
          OpenMenuID = 0;   
          UpdateWorkspace = true;
        }

        
         if(FeedBButtons[8].over() && OpenMenuID == 1)
        {
          println("Pressed Offset Button on FeedB");          
          FeedBButtons[8].Selected = false;
          OpenMenuID = 0;   
          UpdateWorkspace = true;        
        }      
    
    return; //prevent any buttons that are not focused from being clicked
  }//end if

  //=============== END GUI START BUTTONS ==============================
  for (int i=0; i != FeedAButtons.length;i++)
  {
    if (FeedAButtons[i].over())
    {
      HandleFeedAButtons(i);
    }
  }
  //=============== END FEED A ========  START COMMON ==============
  for (int i=0; i != FeedBButtons.length;i++)
  {
    if (FeedBButtons[i].over())
    {
      HandleFeedBButtons(i);
    } //end over if()
  }
  //====================== END FEED B ====================================== 
  for (int i=0; i !=BlendButtons.length;i++)
  {
    if (BlendButtons[i].over())
    {
      HandleBlendButtons(i);
    }//end over() if
  }//end for() 
  //============================================================ 


  for (int i=0; i != 7;i++)
  {
    if (CommonButtons[i].over())
    {
      HandleCommonButtons(i);
    }//end over() if
  }//end for() 

  //============== QUICK FEED BUTTONS =================================================

  for (int i=0; i != QuickAButtons.length;i++)
  {
    if (QuickAButtons[i].over() && FeedAQuickPage == 0 && i < 15)  HandleQuickAButtons(i);
    else if (QuickAButtons[i].over() && FeedAQuickPage == 1 && i > 14 && i < 30) HandleQuickAButtons(i);
    else if (QuickAButtons[i].over() && FeedAQuickPage == 2 && i > 29 && i < 45) HandleQuickAButtons(i);
    else if (QuickAButtons[i].over() && FeedAQuickPage == 3 && i > 44 && i < 60) HandleQuickAButtons(i);
  }//end for

  for (int i=0; i != QuickBButtons.length;i++)
  {
    if (QuickBButtons[i].over() && FeedBQuickPage == 0 && i < 15)  HandleQuickBButtons(i);
    else if (QuickBButtons[i].over() && FeedBQuickPage == 1 && i > 14 && i < 30) HandleQuickBButtons(i);
    else if (QuickBButtons[i].over() && FeedBQuickPage == 2 && i > 29 && i < 45) HandleQuickBButtons(i);
    else if (QuickBButtons[i].over() && FeedBQuickPage == 3 && i > 44 && i < 60) HandleQuickBButtons(i);
  }//end for()

  //============ START SLIDERS ================================

  for (int i=0; i != CommonSliders.length;i++)
  {
    if (CommonSliders[i].over())
    {
      SelectedSlider = i;
      CommonSliders[i].selectSlider();
    }
  }//end for

  if (MainMixerSlider.over())
  {   
    SelectedSlider = 0;
    MainMixerSlider.selectSlider();
  }

  if (IntensitySliderA.over())
  {   
    SelectedSlider = 0;
    IntensitySliderA.selectSlider();
  }
  
  if (IntensitySliderB.over())
  {   
    SelectedSlider = 0;
    IntensitySliderB.selectSlider();
  }
}//end func

//================================= START BUTTON HANDLERS =================================

void HandleSliders(boolean bMoveEnable)
{
  println("Dragging "+SliderPointer.SetNumber);
  int mX = round((float)mouseX / SF);
  int mY = round((float)mouseY / SF);     

  if (bMoveEnable == true)
  {
    //when doing a mousewheel or arrow key don't want it to move()
    SliderPointer.move(mX, mY);
  }
  else GlobalDragging = false;
  
   SliderPointer.display(); //moved from here since some sliders draw to different buffer
  
  switch(SliderPointer.SetNumber)
  {
  case 0: //mixer
    MixerValue = (float)MainMixerSlider.Value / 100;  
    break;
  case 1: //intensityA
    IntensityValueA = (float)IntensitySliderA.Value / 100;  
    if (LockIntensity == true) 
    {
      IntensityValueB = (float)IntensitySliderA.Value / 100;  
      IntensitySliderB.Value = IntensitySliderA.Value;
      IntensitySliderB.display();  //display new position
    }
    break;
  case 2: //intensityB
    IntensityValueB = (float)IntensitySliderB.Value / 100;  
    if (LockIntensity == true)
    {
      IntensityValueA = (float)IntensitySliderB.Value / 100;  
      IntensitySliderA.Value = IntensitySliderB.Value;
      IntensitySliderA.display();  //display new position
    }
    break;     
    
  case 3: //CommonButtons
    switch(SelectedSlider)
    {
      case 0: //FeedA Red
        QuickFeeds[FeedASelQuick].SliderRed = CommonSliders[SelectedSlider].Value;
      break;
      case 1: //FeedA Green
        QuickFeeds[FeedASelQuick].SliderGreen= CommonSliders[SelectedSlider].Value;
      break;   
      case 2: //FeedA Blue
        QuickFeeds[FeedASelQuick].SliderBlue = CommonSliders[SelectedSlider].Value;
      break;      
      case 3:
        QuickFeeds[FeedBSelQuick].SliderRed = CommonSliders[SelectedSlider].Value;
        break;   
      case 4:
        QuickFeeds[FeedBSelQuick].SliderGreen = CommonSliders[SelectedSlider].Value;
        break;  
      case 5:
        QuickFeeds[FeedBSelQuick].SliderBlue = CommonSliders[SelectedSlider].Value;
        break;
      case 6:
      println("This handled");
          try {
            if (QuickFeeds[FeedASelQuick].Speed < 0) myMovieA.speed(0.1); //prevents the movie object from going in reverse or 0
            else myMovieA.speed(QuickFeeds[FeedASelQuick].Speed);
          }
          catch(Exception e) {
          }   
          QuickFeeds[FeedASelQuick].Speed = (((float)CommonSliders[6].Value-100) /10);
          RedrawSpeeds();
        break;
      case 7://handle SpeedB
        QuickFeeds[FeedBSelQuick].Speed = (((float)CommonSliders[7].Value-100) / 10);
        try {
          if (QuickFeeds[FeedBSelQuick].Speed < 0) myMovieB.speed(0.1);  //prevents the movie object from going in reverse or 0
          else myMovieB.speed(QuickFeeds[FeedBSelQuick].Speed);
        }
        catch(Exception e) {
        } //if no Movie object is there, then nothing happens as the other methods read Quckfeeds[].Speed 
        QuickFeeds[FeedBSelQuick].Speed = (((float)CommonSliders[7].Value-100) /10);    
        RedrawSpeeds();
        break;          
      case 8: //contrast Feed A   
        QuickFeeds[FeedASelQuick].ContrastValue = CommonSliders[SelectedSlider].Value;
        break;
      case 9: //contrast Feed B   
        QuickFeeds[FeedBSelQuick].ContrastValue = CommonSliders[SelectedSlider].Value;
        break;      
    } //end switch
    break;
  case 4: 
    //move the slider values into their respective QuickFeed Object variable
    if (FeedFlag == true) //A, set when the button is pressed to open the menu
    {
      QuickFeeds[FeedASelQuick].GenSlider1 = GenerationSliders[0].Value;
      QuickFeeds[FeedASelQuick].GenSlider2 = GenerationSliders[1].Value;
      QuickFeeds[FeedASelQuick].GenSlider3 = GenerationSliders[2].Value;
      QuickFeeds[FeedASelQuick].GenSlider4 = GenerationSliders[3].Value;
      GUIMenus[OpenMenuID].display();
    }
    else
    {
      QuickFeeds[FeedBSelQuick].GenSlider1 = GenerationSliders[0].Value;
      QuickFeeds[FeedBSelQuick].GenSlider2 = GenerationSliders[1].Value;
      QuickFeeds[FeedBSelQuick].GenSlider3 = GenerationSliders[2].Value;
      QuickFeeds[FeedBSelQuick].GenSlider4 = GenerationSliders[3].Value;
      GUIMenus[OpenMenuID].display();      
    }
    break;
  }//end switch()
} //end func

//========================== END HANDLE SLIDERS =========================================

void HandleBlendButtons(int PassedID)
{
  println("Blend Button: "+PassedID);  
  //unselects all buttons then sets the pressed one
  for (int y=0; y != BlendButtons.length;y++)  BlendButtons[y].Selected = false;
  BlendButtons[PassedID].Selected =! BlendButtons[PassedID].Selected;
  BlendingMode = PassedID;
  for (int i=0; i != BlendButtons.length;i++)  BlendButtons[i].display();
}

void HandleCommonButtons(int PassedID)
{
  int i = PassedID;
  println("HandleCommonButtons() "+i);

  CommonButtons[i].Selected =! CommonButtons[i].Selected;
  CommonButtons[i].display();   

  switch(i)
  {
  case 0://A
    MainMixerSlider.Value = 0;
    MixerValue = (float)MainMixerSlider.Value / 100;     
    MainMixerSlider.display();    
    break;        
  case 1: //B
    MainMixerSlider.Value = 100;    
    MixerValue = (float)MainMixerSlider.Value / 100;          
    MainMixerSlider.display();
    break;   
  case 2: //AutoFade
    AutoSequenceRunning = true;
    TransitionFlag = true;
    if (MixerValue > 0.5) FeedID = true;
    else FeedID = false;
    BlendSpeed = cDefaultAutoFadeSpeed;
    break;    
  case 3: //Enable Automatic Mode
    if (CommonButtons[i].Selected == true)
    {
      AutoSequenceRunning = true;
      AutomaticMode = true;
      LoadAutoFile();
    }
    else
    {
      AutoSequenceRunning = false; 
      AutomaticMode = false;
    }
    break;    
  case 4: //Lock Intensity
    if (CommonButtons[i].Selected == true) LockIntensity = true;
    else  LockIntensity = false;
    break;         
  case 5: //save QuickFeeds
    SaveQuickFeedsFile();
    break;  
  case 6: //Load QuickFeeds
    LoadQuickFeedsFile();
    break;
  case 7: //open Main Menu
    if (CommonButtons[i].Selected == true)
    {
      CommonButtons[8].Selected = false;
      CommonButtons[8].display();          
      GUIMenus[OpenMenuID].Opened = false;       
      OpenMenuID = 2;
      GUIMenus[OpenMenuID].Opened = true;     
      GUIMenus[OpenMenuID].display();
    }
    else
    {
      GUIMenus[2].Opened = false;    
      OpenMenuID = 0;
      UpdateWorkspace = true;
    }
    break;
  case 8: //Configure Menu
    if (CommonButtons[i].Selected == true)
    {
      CommonButtons[7].Selected = false;
      CommonButtons[7].display();    
      GUIMenus[OpenMenuID].Opened = false; 
      OpenMenuID = 3;
      GUIMenus[OpenMenuID].Opened = true;    
      GUIMenus[OpenMenuID].display();
    }
    else
    {
      GUIMenus[3].Opened = false; 
      OpenMenuID = 0;
      UpdateWorkspace = true;
    }  
    break;    
  case 9: //Gen Menu A
    if (CommonButtons[i].Selected == true)
    {
      CommonButtons[10].Selected = false;
      CommonButtons[10].display();    
      FeedFlag = true; //A
      GenerationSliders[0].Value =  QuickFeeds[FeedASelQuick].GenSlider1; //initialize the slider values with the saved values
      GenerationSliders[1].Value =  QuickFeeds[FeedASelQuick].GenSlider2; //initialize the slider values with the saved values
      GenerationSliders[2].Value =  QuickFeeds[FeedASelQuick].GenSlider3; //initialize the slider values with the saved values
      GenerationSliders[3].Value =  QuickFeeds[FeedASelQuick].GenSlider4; //initialize the slider values with the saved values  

      GUIMenus[OpenMenuID].Opened = false; 
      OpenMenuID = 4;
      GUIMenus[OpenMenuID].Toggle();
      GUIMenus[OpenMenuID].display();
    }
    else
    {
      GUIMenus[OpenMenuID].Toggle();
      OpenMenuID = 0;
      UpdateWorkspace = true;
    }  
    break;       
  case 10: //Gen Menu B
    if (CommonButtons[i].Selected == true)
    {
      CommonButtons[9].Selected = false;
      CommonButtons[9].display();
      FeedFlag = false; //B
      GenerationSliders[0].Value =  QuickFeeds[FeedBSelQuick].GenSlider1; //initialize the slider values with the saved values
      GenerationSliders[1].Value =  QuickFeeds[FeedBSelQuick].GenSlider2; //initialize the slider values with the saved values
      GenerationSliders[2].Value =  QuickFeeds[FeedBSelQuick].GenSlider3; //initialize the slider values with the saved values
      GenerationSliders[3].Value =  QuickFeeds[FeedBSelQuick].GenSlider4; //initialize the slider values with the saved values            

      GUIMenus[OpenMenuID].Opened = false; 
      OpenMenuID = 5;
      GUIMenus[OpenMenuID].Toggle();
      GUIMenus[OpenMenuID].display();
    }
    else
    {
      GUIMenus[OpenMenuID].Toggle();      
      OpenMenuID = 0;
      UpdateWorkspace = true;
    }    
    break;
  }//end switch
}//end func


void HandleQuickAButtons(int PassedID)
{
  println("HandleQuickAButtons Pressed: "+PassedID);
  int i = PassedID;
  //check, highlight and display the preview
  if (QuickAButtons[i].Focused == false && QuickAButtons[i].Selected == false && AutomaticMode == false && Matrix.softwareLrgPreviewEnable == true)
  {
    //will highlight and open the full size preview 
    QuickAButtons[PrevFocusA].Focused = false;
    QuickAButtons[PrevFocusA].displaySq(PrevFocusA);  

    QuickAButtons[i].Focused = true;
    QuickAButtons[i].displaySq(i);
    PrevFocusA = i;
    PreviewQuickFeed(i);
    return;
  }
  //else it will select the quickfeed normally

  DisplayPreview = false;
  QuickAButtons[FeedASelQuick].Selected = false;  
  QuickAButtons[FeedASelQuick].Focused = false;  
//  QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick); //display previously selected button as unselected
    //don't want to display when its not on the page
    if (FeedAQuickPage == 0 && FeedASelQuick < 15)  QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick);
    else if ( FeedAQuickPage == 1 && FeedASelQuick > 14 && FeedASelQuick < 30) QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick);
    else if (FeedAQuickPage == 2 && FeedASelQuick > 29 && FeedASelQuick < 45) QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick);
    else if ( FeedAQuickPage == 3 && FeedASelQuick > 44 && FeedASelQuick < 60) QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick);

  //save slider values before switching QuickFeeds
  QuickFeeds[FeedASelQuick].SliderRed = CommonSliders[0].Value;
  QuickFeeds[FeedASelQuick].SliderGreen = CommonSliders[1].Value;
  QuickFeeds[FeedASelQuick].SliderBlue = CommonSliders[2].Value;
  QuickFeeds[FeedASelQuick].ContrastValue = CommonSliders[8].Value;

  FeedASelQuick = i;
  QuickAButtons[FeedASelQuick].Selected = true;
  QuickAButtons[FeedASelQuick].displaySq(FeedASelQuick); //highlight recently selected button

  LoadQuickFeed(myMovieA, QuickFeeds[FeedASelQuick]);
}


void HandleQuickBButtons(int PassedID)
{
  println("QuickFeedB Pressed: "+PassedID);
  int i = PassedID;
  //check, highlight and display the preview
  if (QuickBButtons[i].Focused == false && QuickBButtons[i].Selected == false && AutomaticMode == false && Matrix.softwareLrgPreviewEnable == true)
  {
    //will highlight and open the full size preview 
    QuickBButtons[PrevFocusB].Focused = false;
    QuickBButtons[PrevFocusB].displaySq(PrevFocusB);  
    QuickBButtons[i].Focused = true;
    QuickBButtons[i].displaySq(i);
    PrevFocusB = i;
    PreviewQuickFeed(i);
    return;
  }
  //else it will select the quickfeed normally

  DisplayPreview = false;
  QuickBButtons[FeedBSelQuick].Selected = false;  
  QuickBButtons[FeedBSelQuick].Focused = false;  
//  QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick); //display previously selected button as unselected
    //don't want to display when its not on the page
    if (FeedBQuickPage == 0 && FeedBSelQuick < 15)  QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick);
    else if ( FeedBQuickPage == 1 && FeedBSelQuick > 14 && FeedBSelQuick < 30) QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick);
    else if (FeedBQuickPage == 2 && FeedBSelQuick > 29 && FeedBSelQuick < 45) QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick);
    else if ( FeedBQuickPage == 3 && FeedBSelQuick > 44 && FeedBSelQuick < 60) QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick);

  //save slider values before switching QuickFeeds
  QuickFeeds[FeedBSelQuick].SliderRed = CommonSliders[3].Value;
  QuickFeeds[FeedBSelQuick].SliderGreen = CommonSliders[4].Value;
  QuickFeeds[FeedBSelQuick].SliderBlue = CommonSliders[5].Value;
  QuickFeeds[FeedBSelQuick].ContrastValue = CommonSliders[9].Value;

  FeedBSelQuick = i;
  QuickBButtons[FeedBSelQuick].Selected = true;
  QuickBButtons[FeedBSelQuick].displaySq(FeedBSelQuick); //highlight recently selected button

  LoadQuickFeed(myMovieB, QuickFeeds[FeedBSelQuick]);
}

//======================================================================================

void HandleFeedAButtons(int PassedID)
{
  int i = PassedID; //move passedID into i, since it was already written using i
  FeedAButtons[i].Selected =! FeedAButtons[i].Selected;
  FeedAButtons[i].display();   
  println("FeedA Button: "+i);

  switch(i)
  {
  case 0://Play
    QuickFeeds[FeedASelQuick].ControlState = 0;        
    SetControlStateFunc(myMovieA, FeedAButtons, QuickFeeds[FeedASelQuick].ControlState);            
    break;
  case 1: //Pause
    QuickFeeds[FeedASelQuick].ControlState = 1;              
    SetControlStateFunc(myMovieA, FeedAButtons, QuickFeeds[FeedASelQuick].ControlState);            
    break;
  case 2: //Stop
    QuickFeeds[FeedASelQuick].ControlState = 2;               
    SetControlStateFunc(myMovieA, FeedAButtons, QuickFeeds[FeedASelQuick].ControlState);            
    break;
  case 3: //Load File
    LoadFileMethod = 0;
    FeedFlag = true; //A
    selectInput("Select a file to process:", "fileSelected");
    break; 
  case 4: //reset speed
    CommonSliders[6].Value = cDefaultSpeedX1;  
    HandleSliders(false); //handle SpeedA
    break;        
  case 5: //invert
    //bit more confusing as 1 is invert, 2 is contrast and 3 is both
    if (FeedAButtons[i].Selected == true) 
    {
      if (QuickFeeds[FeedASelQuick].EffectState == 2) QuickFeeds[FeedASelQuick].EffectState = 3;
      else  QuickFeeds[FeedASelQuick].EffectState = 1;
    }
    else 
    {
      if (QuickFeeds[FeedASelQuick].EffectState == 2 || QuickFeeds[FeedASelQuick].EffectState == 3) QuickFeeds[FeedASelQuick].EffectState = 2; 
      else QuickFeeds[FeedASelQuick].EffectState = 0;
    } 
    break;  
  case 6: //tint
    if (FeedAButtons[i].Selected == true) 
    {
      QuickFeeds[FeedASelQuick].ColorState = 1;
      CommonSliders[0].Value = 0; //intialize color sliders
      CommonSliders[1].Value = 0;
      CommonSliders[2].Value = 0; 
      SetColorStateFunc(FeedAButtons, QuickFeeds[FeedASelQuick].ColorState );
    }
    else QuickFeeds[FeedASelQuick].ColorState = 0;  
    break;     
  case 7://color max
    if (FeedAButtons[i].Selected == true) 
    {
      QuickFeeds[FeedASelQuick].ColorState = 2;
      CommonSliders[0].Value = 255; //intialize color sliders
      CommonSliders[1].Value = 255;
      CommonSliders[2].Value = 255;   
      SetColorStateFunc(FeedAButtons, QuickFeeds[FeedASelQuick].ColorState );
    }
    else QuickFeeds[FeedASelQuick].ColorState = 0;
    break; 
  case 8: //offset
    FeedFlag = true; //A
    if (FeedAButtons[8].Selected == true)  OpenMenuID = 1;
    else OpenMenuID = 0;
    break;
  case 9: //Color Scale
    if (FeedAButtons[i].Selected == true) 
    {
      QuickFeeds[FeedASelQuick].ColorState = 3;
      CommonSliders[0].Value = 255; //intialize color sliders
      CommonSliders[1].Value = 255;
      CommonSliders[2].Value = 255;   
      SetColorStateFunc(FeedAButtons, QuickFeeds[FeedASelQuick].ColorState );
    }
    else QuickFeeds[FeedASelQuick].ColorState = 0;
    break;     
  case 10: //Color Min
    if (FeedAButtons[i].Selected == true) 
    {
      QuickFeeds[FeedASelQuick].ColorState = 4;
      CommonSliders[0].Value = 0; //intialize color sliders
      CommonSliders[1].Value = 0;
      CommonSliders[2].Value = 0; 
      SetColorStateFunc(FeedAButtons, QuickFeeds[FeedASelQuick].ColorState );
    }
    break;       
  case 11: //Contrast
    //bit more confusing as 1 is invert, 2 is contrast and 3 is both
    if (FeedAButtons[i].Selected == true) 
    {
      if (QuickFeeds[FeedASelQuick].EffectState == 1) QuickFeeds[FeedASelQuick].EffectState = 3;
      else  QuickFeeds[FeedASelQuick].EffectState = 2;
    }
    else 
    {
      if (QuickFeeds[FeedASelQuick].EffectState == 1 || QuickFeeds[FeedASelQuick].EffectState == 3) QuickFeeds[FeedASelQuick].EffectState = 1; 
      else QuickFeeds[FeedASelQuick].EffectState = 0;
    }
    break;      
  case 12: //Pg Up
    if (FeedAQuickPage == 3) FeedAQuickPage = 0;
    else FeedAQuickPage++;
    for (int x=0; x != 15;x++)   QuickAButtons[x+(FeedAQuickPage*15)].displaySq(x+(FeedAQuickPage*15));
    break;   
  case 13: //Pg Down
    if (FeedAQuickPage == 0) FeedAQuickPage = 3;
    else FeedAQuickPage--;  
    for (int x=0; x != 15;x++)   QuickAButtons[x+(FeedAQuickPage*15)].displaySq(x+(FeedAQuickPage*15));
    break;
  } //end switch
}//end func

//======================================================================================

void HandleFeedBButtons(int PassedID)
{
  int i = PassedID; //move passedID into i, since it was already written using i
  FeedBButtons[i].Selected =! FeedBButtons[i].Selected;
  FeedBButtons[i].display();   
  println("FeedB Button: "+i);

  switch(i)
  {
  case 0://Play
    QuickFeeds[FeedBSelQuick].ControlState = 0;        
    SetControlStateFunc(myMovieB, FeedBButtons, QuickFeeds[FeedBSelQuick].ControlState);            
    break;
  case 1: //Pause
    QuickFeeds[FeedBSelQuick].ControlState = 1;              
    SetControlStateFunc(myMovieB, FeedBButtons, QuickFeeds[FeedBSelQuick].ControlState);            
    break;
  case 2: //Stop
    QuickFeeds[FeedBSelQuick].ControlState = 2;               
    SetControlStateFunc(myMovieB, FeedBButtons, QuickFeeds[FeedBSelQuick].ControlState);            
    break;
  case 3: //Load File
    LoadFileMethod = 0;
    FeedFlag = false; //B
    selectInput("Select a file to process:", "fileSelected");
    break; 
  case 4: //reset speed
    CommonSliders[6].Value = cDefaultSpeedX1;  
    HandleSliders(false); //handle SpeedB
    break;        
  case 5: //invert
    //bit more confusing as 1 is invert, 2 is contrast and 3 is both
    if (FeedBButtons[i].Selected == true) 
    {
      if (QuickFeeds[FeedBSelQuick].EffectState == 2) QuickFeeds[FeedBSelQuick].EffectState = 3;
      else  QuickFeeds[FeedBSelQuick].EffectState = 1;
    }
    else 
    {
      if (QuickFeeds[FeedBSelQuick].EffectState == 2 || QuickFeeds[FeedBSelQuick].EffectState == 3) QuickFeeds[FeedBSelQuick].EffectState = 2; 
      else QuickFeeds[FeedBSelQuick].EffectState = 0;
    } 
    break;  
  case 6: //tint
    if (FeedBButtons[i].Selected == true) 
    {
      QuickFeeds[FeedBSelQuick].ColorState = 1;
      CommonSliders[3].Value = 0; //intialize color sliders
      CommonSliders[4].Value = 0;
      CommonSliders[5].Value = 0; 
      SetColorStateFunc(FeedBButtons, QuickFeeds[FeedBSelQuick].ColorState );
    }
    else QuickFeeds[FeedBSelQuick].ColorState = 0;  
    break;     
  case 7://color max
    if (FeedBButtons[i].Selected == true) 
    {
      QuickFeeds[FeedBSelQuick].ColorState = 2;
      CommonSliders[3].Value = 255; //intialize color sliders
      CommonSliders[4].Value = 255;
      CommonSliders[5].Value = 255;   
      SetColorStateFunc(FeedBButtons, QuickFeeds[FeedBSelQuick].ColorState );
    }
    else QuickFeeds[FeedBSelQuick].ColorState = 0;
    break; 
  case 8: //offset
    FeedFlag = false; //B
    if (FeedBButtons[8].Selected == true)  OpenMenuID = 1;
    else OpenMenuID = 0;
    break;
  case 9: //Color Scale
    if (FeedBButtons[i].Selected == true) 
    {
      QuickFeeds[FeedBSelQuick].ColorState = 3;
      CommonSliders[3].Value = 255; //intialize color sliders
      CommonSliders[4].Value = 255;
      CommonSliders[5].Value = 255;   
      SetColorStateFunc(FeedBButtons, QuickFeeds[FeedBSelQuick].ColorState );
    }
    else QuickFeeds[FeedBSelQuick].ColorState = 0;
    break;     
  case 10: //Color Min
    if (FeedBButtons[i].Selected == true) 
    {
      QuickFeeds[FeedBSelQuick].ColorState = 4;
      CommonSliders[3].Value = 0; //intialize color sliders
      CommonSliders[4].Value = 0;
      CommonSliders[5].Value = 0; 
      SetColorStateFunc(FeedBButtons, QuickFeeds[FeedBSelQuick].ColorState );
    }
    break;       
  case 11: //Contrast
    //bit more confusing as 1 is invert, 2 is contrast and 3 is both
    if (FeedBButtons[i].Selected == true) 
    {
      if (QuickFeeds[FeedBSelQuick].EffectState == 1) QuickFeeds[FeedBSelQuick].EffectState = 3;
      else  QuickFeeds[FeedBSelQuick].EffectState = 2;
    }
    else 
    {
      if (QuickFeeds[FeedBSelQuick].EffectState == 1 || QuickFeeds[FeedBSelQuick].EffectState == 3) QuickFeeds[FeedBSelQuick].EffectState = 1; 
      else QuickFeeds[FeedBSelQuick].EffectState = 0;
    }
    break;      
  case 12: //Pg Up
    if (FeedBQuickPage == 3) FeedBQuickPage = 0;
    else FeedBQuickPage++;
    for (int x=0; x != 15;x++)   QuickBButtons[x+(FeedBQuickPage*15)].displaySq(x+(FeedBQuickPage*15));
    break;   
  case 13: //Pg Down
    if (FeedBQuickPage == 0) FeedBQuickPage = 3;
    else FeedBQuickPage--;  
    for (int x=0; x != 15;x++)   QuickBButtons[x+(FeedBQuickPage*15)].displaySq(x+(FeedBQuickPage*15));
    break;
  } //end switch
}//end func

