//Forgot where this code was from, figure it out so I can give credit
//but monitors a DShow capture, such as ManyCam or webcams, good for patching in Milkdrop or similair visiuals



class DCapture implements java.beans.PropertyChangeListener {

	private DSCapture capture;
	public int width, height;

	DCapture() {
		DSFilterInfo[][] dsi = DSCapture.queryDevices();
		capture = new DSCapture(DSFiltergraph.DD7, dsi[0][0], false, 
		DSFilterInfo.doNotRender(), this);
		width = capture.getDisplaySize().width;
		height = capture.getDisplaySize().height;
	}

	public PImage updateImage() {
		PImage img = createImage(width, height, RGB);
		BufferedImage bimg = capture.getImage();
		bimg.getRGB(0, 0, img.width, img.height, img.pixels, 0, img.width);
		img.updatePixels();
		return img;
	}

	public void propertyChange(java.beans.PropertyChangeEvent e) {
		switch (DSJUtils.getEventType(e)) {
		}
	}
}




void DrawGenerated(PGraphics buf)
{
	//All Generated/.DAT/Non-Video feeds come through here
	//The first time through for a Feed, The FrameFirstRun should be set so it can initilize using the switch()

	//Then it will run whenever called, the speed is a float, so really slow and really fast frame rates are supported and called from draw()

	//Many of the generated graphics were taken from the internet from various websites and programmers. Each should have a linkback to the orignal
	//  project it was taken from. If more are added please ensure to give credit back to the original programmer.

	int BufferIDNum = IdentifyBufferID(buf);
	
	//remove this and use BufferIDNum, make global?
	if (buf == GraphicsBufferA) FrameMethod = FrameMethodA;
	else  FrameMethod = FrameMethodB; //generation also else's and uses frameB

	if (FrameFirstRun == true)
	{
		FrameFirstRun = false;
		println("Method Init, FirstRun "+FrameMethod);

		//First Initialize the generated content
		buf.beginDraw();
		
		//some defaults
		buf.colorMode(RGB, 255); //required or wierd things happen
		buf.rectMode(CORNER);       
		buf.strokeWeight(1);

		switch(FrameMethod)
		{
		case 1: //capture from input
			if (captureDSObj == null && Matrix.softwareEnableDSVideoFeed == true)
			{
				captureDSObj = new DCapture();
				println("Capture: "+captureDSObj.width+" : "+captureDSObj.height);
			}   
			if (buf == GraphicsBufferA)  arrayCopy(cNotUsedLabels, GenSliderLabelsA);
			else arrayCopy(cNotUsedLabels, GenSliderLabelsB); //copy labels from constants
			break;
		case 2: //image
			genGraphicImage[BufferIDNum] = new ggObjImage();		
			genGraphicImage[BufferIDNum].ggInitilaize(buf);		
			break;
		case 3: // .dat file
			genGraphicDATFile[BufferIDNum] = new ggObjDATFile();		
			genGraphicDATFile[BufferIDNum].ggInitilaize(buf);			
			break;
		case 4: //Text	
			genGraphicText[BufferIDNum] = new ggObjText();		
			genGraphicText[BufferIDNum].ggInitilaize(buf);
			break;    

		
		case 101://star field
			genGraphicStarField[BufferIDNum] = new ggObjStarField();		
			genGraphicStarField[BufferIDNum].ggInitilaize(buf);
			break;
		case 102: //spinning square
			genGraphicSpinningSquare[BufferIDNum] = new ggObjSpinningSquare();		
			genGraphicSpinningSquare[BufferIDNum].ggInitilaize(buf);
			break;
		case 103: //circle ripples
 			genGraphicRipples[BufferIDNum] = new ggObjRipples();		
			genGraphicRipples[BufferIDNum].ggInitilaize(buf); 
			break;
		case 104: //metaballs
 			genGraphicMetaBalls[BufferIDNum] = new ggObjMetaBalls();		
			genGraphicMetaBalls[BufferIDNum].ggInitilaize(buf); 
			break;
		case 105: //strange plasma
 			genGraphicPlasma[BufferIDNum] = new ggObjPlasma();		
			genGraphicPlasma[BufferIDNum].ggInitilaize(buf);
			break;	
		case 106: //spiral
 			genGraphicSpiral[BufferIDNum] = new ggObjSpiral();		
			genGraphicSpiral[BufferIDNum].ggInitilaize(buf);
			break; 	
		case 109: //falling blocks
  			genGraphicFallingBlocks[BufferIDNum] = new ggObjFallingBlocks();		
			genGraphicFallingBlocks[BufferIDNum].ggInitilaize(buf);  
			break;
		case 123: //test step through
     		genGraphicTestStepThrough[BufferIDNum] = new ggObjTestStepThrough();		
			genGraphicTestStepThrough[BufferIDNum].ggInitilaize(buf);       
			break;	
	
			
		case 200: //audio reactive cirlce
       		genGraphicAudioCircles[BufferIDNum] = new ggObjAudioCircles();		
			genGraphicAudioCircles[BufferIDNum].ggInitilaize(buf);         
			break;			
		case 201: //Audio Sine Wave
        	genGraphicAudioSine[BufferIDNum] = new ggObjAudioSine();		
			genGraphicAudioSine[BufferIDNum].ggInitilaize(buf);    
			break;
		case 202: //audio bars
        	genGraphicAudioBars[BufferIDNum] = new ggObjAudioBars();		
			genGraphicAudioBars[BufferIDNum].ggInitilaize(buf);            
			break;
		}//end switch
	}//end if

	//======================================== END SETUP ========================================

	if (buf == GraphicsBufferA) //moves QuickFeed stored Generation variables into hold registers
	{
		HoldGenSlider1 = QuickFeeds[FeedASelQuick].GenSlider1;
		HoldGenSlider2 = QuickFeeds[FeedASelQuick].GenSlider2;
		HoldGenSlider3 = QuickFeeds[FeedASelQuick].GenSlider3;
		HoldGenSlider4 = QuickFeeds[FeedASelQuick].GenSlider4;
	}
	else  if (buf == GraphicsBufferB)
	{
		HoldGenSlider1 = QuickFeeds[FeedBSelQuick].GenSlider1;
		HoldGenSlider2 = QuickFeeds[FeedBSelQuick].GenSlider2;
		HoldGenSlider3 = QuickFeeds[FeedBSelQuick].GenSlider3;
		HoldGenSlider4 = QuickFeeds[FeedBSelQuick].GenSlider4;
	}
	else
	{
		//generating previews thumbnails
		HoldGenSlider1 = QuickFeeds[DisplayThumbnail].GenSlider1;
		HoldGenSlider2 = QuickFeeds[DisplayThumbnail].GenSlider2;
		HoldGenSlider3 = QuickFeeds[DisplayThumbnail].GenSlider3;
		HoldGenSlider4 = QuickFeeds[DisplayThumbnail].GenSlider4;
	}
	//========================== START DRAW ==========================================

	switch(FrameMethod)
	{
	case 0: //Movie, so nothing happens here

		break;
	case 1: //DShow capture
		try {
			if (buf == GraphicsBufferA) buf.image(cap.updateImage(), 0+QuickFeeds[FeedASelQuick].OffsetX, 0+QuickFeeds[FeedASelQuick].OffsetY, MatrixWidth+(MatrixWidth/4), MatrixHeight+(MatrixHeight/4));  
			else  
			{
				buf.image(cap.updateImage(), 0, 0, MatrixWidth+(MatrixWidth/4), MatrixHeight+(MatrixHeight/4));
			}
		}
		catch(Exception e)
		{
			println("No DShow capture avaialable.");
		} 
		break; 
	case 2: //image
		//never gets here
		break;    
	case 3: // .dat video files
		genGraphicDATFile[BufferIDNum].ggFillBuffer();	
		break;  
	case 4: //Text 
		genGraphicText[BufferIDNum].ggFillBuffer();
		break;        	
	//============  start generated methods, end System methods     ======================================
	case 101://star field
		genGraphicStarField[BufferIDNum].ggFillBuffer();
		break;		
	case 102: //spinning cube
		genGraphicSpinningSquare[BufferIDNum].ggFillBuffer();	
		break;  		
	case 103: //ripples
		genGraphicRipples[BufferIDNum].ggFillBuffer();	
		break;  		
	case 104: //balls
		genGraphicMetaBalls[BufferIDNum].ggFillBuffer();	
		break;		
	case 105: //plasma
		genGraphicPlasma[BufferIDNum].ggFillBuffer();		
		break;
	case 106: //spiral
		genGraphicSpiral[BufferIDNum].ggFillBuffer();	
		break;
	//7
	//8	
		
	case 109: //falling blocks
		genGraphicFallingBlocks[BufferIDNum].ggFillBuffer();
		break;	
	case 123: //test Step Through
		genGraphicTestStepThrough[BufferIDNum].ggFillBuffer();	
		break;		
	
	//============  start audio generated methods ======================================
	case 200: //Sound Reactive Circle
		genGraphicAudioCircles[BufferIDNum].ggFillBuffer();	
		break;		
	case 201: //Audio Sine Wave
		genGraphicAudioSine[BufferIDNum].ggFillBuffer();	
		break;
	case 202: //Sound Reactive Bars, best at low framerate
		genGraphicAudioBars[BufferIDNum].ggFillBuffer();	
		break;	
	}//end switch
	buf.endDraw();
}//end function


void DecayBuffer(float passedValue, PGraphics buf)
{
	//multi use function for decay/trail effect
	buf.loadPixels();
	for (int i = 0;i != buf.pixels.length; i++) //decay/ fade out entire pixel[] array
	{
		myColor = buf.pixels[i];
		myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
		myGreen = myColor >> 8 & 0xFF;
		myBlue = myColor & 0xFF; 
		buf.pixels[i] = color(round(myRed*passedValue), round(myGreen*passedValue), round(myBlue*passedValue));
		//buf.pixels[i] = color(hue(buf.pixels[i]), 100, brightness(buf.pixels[i])-1); //didn't work to adjust brightness
	}
	buf.updatePixels();  
}

//================================ END BUFFER DRAW =====================================

void LoadVideoDataFrame(PGraphics buf)
{ 
	//Buffer Arrays are defined and filled elsewhere and this function just moves data from the byte buffer array to the PGraphics array
	//   for reading the whole .dat file should be already cached to a ByteBuffer array of the exact size

	int HoldFrame  = 0;
	int HoldBufferLen = 0;

	if (buf == GraphicsBufferA) 
	{
		HoldFrame  = DataFrameFeedA;
		HoldBufferLen = ByteBufferA.length;
	}
	else 
	{
		HoldFrame = DataFrameFeedB;
		HoldBufferLen = ByteBufferB.length;
	}

	if (ReverseFlag == true)   
	{
		HoldFrame--; //decrease frame var, if it is belo 0, make it Maximum + -number = new frame value
		if (HoldFrame < 0) HoldFrame = round(HoldBufferLen/MaxChannels) + HoldFrame; //A and B are the same size
	}
	else
	{
		HoldFrame++;
		if ((HoldFrame*MaxChannels) >= HoldBufferLen) HoldFrame = 0;
	}

	int TempBC = HoldFrame * MaxChannels;
	int TempEnd = TempBC + MaxChannels; //should be ok since it is checked before leaving, what about scratching?

	int x = 0;
	buf.loadPixels();
	try {
		if (buf == GraphicsBufferA) 
		{
			for (int i = TempBC; i < TempEnd; i+=3) 
			{
				buf.pixels[x]=color(int(ByteBufferA[i]), int(ByteBufferA[i+1]), int(ByteBufferA[i+2]));
				x++;
			} 
			DataFrameFeedA = HoldFrame;
		}
		else 
		{
			for (int i = TempBC; i < TempEnd; i+=3) 
			{
				buf.pixels[x]=color(int(ByteBufferB[i]), int(ByteBufferB[i+1]), int(ByteBufferB[i+2]));
				x++;
			} 
			DataFrameFeedB = HoldFrame;
		}
	}
	catch(Exception e)
	{
		println("Something, Somewhere went wrong!!!");
	}
	buf.updatePixels();
} //end func

